# -*- coding: utf-8 -*-
import pygame
from pygame.locals import *
import sys

SCREEN_SIZE = (240,280)
map = [[0,0,0],[0,0,0],[0,0,0]]
game_con = 0	# ゲーム状態
turn = 0		# ターン進行
mouse_click = 0	# クリック判定

pygame.init()
screen = pygame.display.set_mode(SCREEN_SIZE)
pygame.display.set_caption("python")

screen2 = pygame.Surface(screen.get_size())
screen2 = screen2.convert()



while True:


	screen.fill((0,128,0))
	screen2.set_alpha(127)
	screen2.set_colorkey((128,0,0))
	screen2.fill((128,0,0))


	pygame.draw.rect(screen, (0,0,0), Rect(0,240,240,40))# メッセージ欄

	if game_con == 0:
		map = [[0,0,0],[0,0,0],[0,0,0]]
		turn = 0
		for event in pygame.event.get():
			if event.type == QUIT:
				sys.exit()
			if event.type == MOUSEBUTTONDOWN and event.button == 1:
				game_con = 1

		pygame.draw.rect(screen, (0,0,0), Rect(0,0,240,280))# 背景を黒で塗りつぶす
		if sys.platform == "win32":
			font = pygame.font.Font(r"c:\windows\fonts\msgothic.ttc", 12)
			text = font.render(u"画面をクリックすると、ゲーム開始です。", True, (255,255,255))
			screen.blit(text, (10,120))
		else :
			font = pygame.font.Font(None, 12)
			text = font.render("Click!", True, (255,255,255))



	elif game_con >= 1:
		# Tキーでタイトルに戻る
		if pygame.key.get_pressed()[K_t]:
			game_con = 0
			turn = 0
			map = [[0,0,0],[0,0,0],[0,0,0]]

		for event in pygame.event.get():
			if event.type == QUIT:
				sys.exit()

			if game_con == 1 :
				# マーク描画判定
				if event.type == MOUSEBUTTONDOWN and event.button == 1:
					x,y = event.pos
					i = 0
					while i < 3:
						ii = 0
						while ii < 3:
							if y >= 10+i*80 and y <= 70+i*80 and x >= 10+ii*80 and x <= 70+ii*80 and map[i][ii] == 0:
								if turn%2 == 0:
									map[i][ii] = 2
								elif turn%2 == 1:
									map[i][ii] = 1
								turn = turn+1
							ii = ii+1
						i = i+1

		# マーク描画部分
		i = 0
		while i < 3:
			ii = 0
			while ii < 3:
				if map[i][ii] == 2:
					pygame.draw.polygon(screen, (0,0,0),((10+ii*80,20+i*80),(60+ii*80,70+i*80),(70+ii*80,60+i*80),(20+ii*80,10+i*80)))
					pygame.draw.polygon(screen, (0,0,0),((20+ii*80,70+i*80),(70+ii*80,20+i*80),(60+ii*80,10+i*80),(10+ii*80,60+i*80)))
				elif map[i][ii] == 1:
					pygame.draw.circle(screen, (0,0,0), (40+ii*80,40+i*80), 30)
					pygame.draw.circle(screen, (0,128,0), (40+ii*80,40+i*80), 20)

				ii = ii+1
			i = i+1



		x, y = pygame.mouse.get_pos()
		i = 0
		while i < 3:
			ii = 0
			while ii < 3:
				if y >= 10+i*80 and y <= 70+i*80 and x >= 10+ii*80 and x <= 70+ii*80:
					pygame.draw.rect(screen2, (0,0,255), Rect(10+ii*80,10+i*80,60,60))
				ii = ii+1
			i = i+1


		#勝敗判定
		if turn >= 9:
			game_con = 4
		i = 0
		while i < 3:
			if map[i][0] == map[i][1] and map[i][0] == map[i][2] :
				if map[i][0] == 2 :
					game_con = 2
					turn = 10
				if map[i][0] == 1 :
					game_con = 3
					turn = 10
			ii = 0
			while ii < 3:
				if map[0][ii] == map[1][ii] and map[0][ii] == map[2][ii] :
					if map[0][ii] == 2 :
						game_con = 2
						turn = 10
					if map[0][ii] == 1 :
						game_con = 3
						turn = 10
				ii = ii+1
			i = i+1

		if map[0][0] == map[1][1] and map[0][0] == map[2][2] :
			if map[0][0] == 2 :
				game_con = 2
				turn = 10
			elif map[0][0] == 1 :
				game_con = 3
				turn = 10

		if map[0][2] == map[1][1] and map[0][2] == map[2][0] :
			if map[0][2] == 2 :
				game_con = 2
				turn = 10
			elif map[0][2] == 1 :
				game_con = 3
				turn = 10


		if sys.platform == "win32":
			#メッセージ描画
			if game_con == 1 :
				if turn%2 == 0 :
					text = font.render(u"×の順番です。", True, (255,255,255))
					screen.blit(text, (20,244))
				elif turn%2 == 1 :
					text = font.render(u"○の順番です。", True, (255,255,255))
					screen.blit(text, (20,244))
			elif game_con > 1 :
				text = font.render(u"ゲームは終了しました。", True, (255,255,255))
				screen.blit(text, (20,254))
				text = font.render(u"Tキーでタイトルに戻ります。", True, (255,255,255))
				screen.blit(text, (20,264))
				if game_con == 2 :
					text = font.render(u"×の勝利です。", True, (255,255,255))
					screen.blit(text, (20,244))
				elif game_con == 3 :
					text = font.render(u"○の勝利です。", True, (255,255,255))
					screen.blit(text, (20,244))
				elif game_con == 4 :
					text = font.render(u"引き分けです。", True, (255,255,255))
					screen.blit(text, (20,244))


		# 枠を描画
		pygame.draw.rect(screen, (0,0,0), Rect(10,75,220,10))
		pygame.draw.rect(screen, (0,0,0), Rect(10,155,220,10))
		pygame.draw.rect(screen, (0,0,0), Rect(75,10,10,220))
		pygame.draw.rect(screen, (0,0,0), Rect(155,10,10,220))

		# ×
		#pygame.draw.polygon(screen, (0,0,0),((10,20),(60,70),(70,60),(20,10)))
		#pygame.draw.polygon(screen, (0,0,0),((20,70),(70,20),(60,10),(10,60)))
		# ○
		#pygame.draw.circle(screen, (0,0,0), (120,40), 30);
		#pygame.draw.circle(screen, (0,128,0), (120,40), 20);
		#pygame.draw.circle(screen, (0,0,0), (120,120), 30);
		#pygame.draw.circle(screen, (0,128,0), (120,120), 20);
		#pygame.draw.circle(screen, (0,0,0), (200,40), 30);
		#pygame.draw.circle(screen, (0,128,0), (200,40), 20);
		#Applet1.fillPolygon(10+ii*80,20+i*80,60+ii*80,70+i*80,70+ii*80,60+i*80,20+ii*80,10+i*80);
		#Applet1.fillPolygon(20+ii*80,70+i*80,70+ii*80,20+i*80,60+ii*80,10+i*80,10+ii*80,60+i*80);

	screen.blit(screen2, (0, 0))
	pygame.display.flip()
	pygame.display.update()
